install.packages("rms")


library(survival)
library(rms)


dir="C:\\Users\\Administrator\\Desktop\\HCC\\TCGA\\11.ͼ"
setwd(dir)
inputfile="multiCoxinput.txt"

miRNA<-read.table(inputfile,header=T,sep="\t",row.names = 1,check.names = F,stringsAsFactors = F) 

miRNAEXP=log2(miRNA[,3:ncol(miRNA)]+1)
miRNA=cbind(miRNA[,1:2],miRNAEXP)
miRNA[,"survival_time"]=miRNA[,"survival_time"]/365

ddist <- datadist(miRNA)
options(datadist='ddist')
fmla1 <- as.formula(Surv(survival_time,status)~.)
mycox <- coxph(fmla1,data=miRNA)
risk_score<-predict(mycox,type="risk",newdata=miRNA)
risk_level<-as.factor(ifelse(risk_score>median(risk_score),"High","Low"))
write.table(cbind(id=rownames(cbind(miRNA[,1:2],risk_score,risk_level)),cbind(miRNA[,1:2],risk_score,risk_level)),"risk_score.txt",sep="\t",quote=F,row.names=F)


cox2 <- cph(Surv(survival_time,status) ~ .,surv=T,x=T, y=T,data=miRNA)
surv <- Survival(cox2)
#sur_1_year<-function(x)surv(1,lp=x)
sur_3_year<-function(x)surv(3,lp=x)
sur_5_year<-function(x)surv(5,lp=x)

nom_sur<- nomogram(cox2,fun=list(sur_3_year,sur_5_year),lp= F,
                   funlabel=c('3-Year Survival','5-Year survival'),
                   maxscale=100,
                   fun.at=c('0.9','0.8','0.7','0.6','0.5','0.4','0.3','0.2','0.1'))

pdf("nom.pdf",13,8)
plot(nom_sur)
dev.off()

nom_sur
