BiocManager::install("sva")
BiocManager::install("limma")

library(sva)
library(limma)
setwd("C:\\Users\\Administrator\\Desktop\\HCC\\batch normalization")
rt=read.table("merge3.txt",sep="\t",header=T,check.names=F)
rt=as.matrix(rt)
rownames(rt)=rt[,1]
exp=rt[,2:ncol(rt)]
dimnames=list(rownames(exp),colnames(exp))
data=matrix(as.numeric(as.matrix(exp)),nrow=nrow(exp),dimnames=dimnames)
batchType=c(rep(1,433),rep(2,144),rep(3,78),rep(4,94))
modType=c(rep("normal",193),rep("tumor",240),rep("normal",72),rep("tumor",72),rep("normal",39),rep("tumor",39),rep("normal",30),rep("tumor",64))
mod = model.matrix(~as.factor(modType))
outTab=ComBat(data, batchType, mod, par.prior=TRUE)
outTab=rbind(geneNames=colnames(outTab),outTab)
write.table(outTab,file="normalize.txt",sep="\t",quote=F,col.names=F)



